# -*- coding: utf-8 -*-
"""
Created on Sat Feb 13 14:18:45 2021

@author: Filip Zelezny
"""
from numpy.random import normal

class Env:
  _means = {1:-1,2:1,3:-2,4:5,5:0}
  _stdev = 1
  Y = set(_means.keys())
  def action(self, y):
    if y not in self._means.keys():
      raise ValueError("Unrecognized action.")
    r = normal(self._means[y], self._stdev)
    return r

class EvilEnv(Env):
  _means = {1:-1,2:1,3:-2,4:5,5:0}
  _stdev = 1
  _last_y = None
  Y = set(_means.keys())
  def action(self, y):
    if y not in self._means.keys():
      raise ValueError("Unrecognized action.")
    r = 1 if not self._last_y or y == self._last_y%5+1 else -1
    self._last_y = y
    return r